/*
------------------------------------------------------------------------------
This AREXX-Script will convert any image to any number of colors, specified
     by the user in the argument.

Host address: ADPro (Art Department Professional   ASDG)
Written by Jan Van Overbeke, 3-DEE, 1993.
Read the AREXX-Scripti doc, for info about operation and rights!
------------------------------------------------------------------------------
*/

parse arg filename colors
if ~exists(filename)|filename='' then do
	say 'Unable to find image !!!!'
	say 'See Ya...'
	say ''
	exit
	end

/* ---- Is the argument right? ---- */
/* -------------------------------- */
if ~(colors=2|colors=4|colors=8|colors=16|colors=32|colors=64|colors=128|colors=256|colors='HAM'|colors='HAM8'|colors='24Bit') then do
	say 'Unknown number of colors: Wrong argument!'
	say 'See Ya.....'
	say ''
	exit
	end

/* ---- A small thing to define palette size! ---- */
/* ----------------------------------------------- */
palette=0
if colors='HAM' then palette=16
if colors='HAM8' then palette=64
if palette=0 then palette=colors

options results
address 'ADPro'
say 'Colors: Written by JAN VAN OVERBEKE, 3-DEE, 1993'
say 'Image: 'filename
say 'SAVE: IFF 'colors' Colors'
say ''

LFORMAT "UNIVERSAL"
say 'Loading............'
load filename
if RC ~= 0 then do
	say 'Load failed !!!'
	say 'See Ya...'
	say ''
	exit
	end

/* ---- Get info about image: is it gray? ---- */
/* ---- If it is, we'll have do something ---- */
/* ------------------------------------------- */
IMAGE
if pos('GRAY',ADPRO_RESULT)>0 & colors~='24Bit' then do
	say 'Setting Color Data....'
	operator Gray_To_Color
	if RC~=0 then do
		say 'Gray_To_Color failed!!!!!'
		say 'See Ya.....'
		say ''
		exit
		end
	end

/* ---- Only render image when it's not 24Bit!! ---- */
/* ------------------------------------------------- */
if colors~='24Bit' then do
	RENDER_TYPE colors
	if RC ~= 0 then do
		say 'Unable to select the 'colors' colors.'
		say 'See Ya...'
		say ''
		exit
		end
	say 'Converting.........'
	ptotal palette
	pused palette
	EXECUTE
	if RC ~= 0 then do
		say 'Execute failed !!'
		say 'See Ya...'
		say ''
		exit
		end
	SaveMode='IMAGE'
	say 'Saving IMAGE 'colors'......'
	end
	else do
		SaveMode='RAW'
		say 'Saving RAW......'
	     end

SFORMAT "IFF"
if RC~=0 then do
	say 'Unable to select the IFF saver.'
	say 'See Ya........'
	say ''
	exit
	end

filename=filename'.new'
SAVE filename SaveMode
if RC~=0 then do
	say 'Save Failed!!!: Image not saved.'
	say 'See Ya......'
	end
say ''
exit
