/*
-----------------------------------------------------------------------------
This AREXX-Scripts will apply any dither on any image, specified by the
       user in the argument. (0..6)

Host address: ADPro (Art Department Professional   ASDG)
Written by Jan Van Overbeke, 3-DEE, 1993.
Read the AREXX-Scripti doc, for info about operation and rights!
-----------------------------------------------------------------------------
*/

parse arg filename DthrNmr
if ~exists(filename) then do
	say 'Unable to find the image!!!!!'
	say 'See Ya.....'
	say ''
	exit
	end
if ~(DthrNmr<7 & DthrNmr>=0) then do
	say 'Invalid dither number: wrong argument!'
	say 'See Ya......'
	say ''
	exit
	end

options results
address 'ADPro'
say 'Dither: Written by JAN VAN OVERBEKE, 3-DEE, 1993.'
say 'IMAGE: 'filename
say 'SAVE: IFF Original colors (if not 24Bit)'
say 'Dither Number:'DthrNmr
say ''

LFORMAT "UNIVERSAL"
if RC~=0 then do
	say 'Unable to select the UNIVERSAL loader.'
	say 'See Ya......'
	say ''
	exit
	end

SFORMAT "IFF"
if RC~=0 then do
	say 'Unable to select the IFF saver.'
	say 'See Ya......'
	say ''
	exit
	end

say 'Loading.......'
LOAD filename
if RC~=0 then do
	say 'Unable to load the image !!!!!'
	say 'See Ya......'
	say ''
	exit
	end

/* ---- See if loaded image is 24Bit ---- */
/* ----     If it is, then quit      ---- */
/* -------------------------------------- */
IMAGE
help=ADPRO_RESULT
dontrender='ok'
if pos('RENDERED',help)>0|pos('BITPLANE',help)>0 then dontrender='nok'
if dontrender='ok' then do
	say 'Sorry!'
	say "ADPro can't apply any dithering on a 24Bit image!"
	say 'See Ya.....'
	say ''
	exit
	end

/* ---- Keep palette appropriate to image! ---- */
/* -------------------------------------------- */
render_type
colors=ADPRO_RESULT
palette=0
if colors='HAM' then palette=16
if colors='HAM8' then palette=64
if palette=0 then palette=colors
ptotal palette
pused palette

say 'Converting........'
dither dthrnmr
if RC~=0 then do
	say 'Unable to switch to dither number 'dthrnmr' !!!'
	say 'See Ya.....'
	say ''
	exit
	end

execute
if RC~=0 then do
	say 'Execute failed !!!!!!!'
	say 'See Ya......'
	say ''
	exit
	end

filename=filename'.new'
say 'Saving........'
SAVE filename 'IMAGE'
if RC~=0 then do
	say 'Save failed !!!'
	say 'See Ya......'
	say ''
	exit
	end

say ''
dither 0
exit
